<?php

    #######################################################################
    #                                                                     #
    #              If-CMS - Content Management System for PHP             #
    #              ==========================================             #
    #                                                                     #
    #                    Copyright (c) 2003 Silvio Ricci                  #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   This library is free  software; you can  redistribute it and/or   #
    #   modify  it under  the  terms of the GNU Lesser  General  Public   #
    #   License as published by the  Free  Software  Foundation; either   #
    #   version 2.1 of the License, or any later version.                 #
    #                                                                     #
    #   This library is distributed  in the hope that it will be useful,  #
    #   but WITHOUT  ANY  WARRANTY; without even the implied warranty of  #
    #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  #
    #   Lesser General Public License for more details.                   #
    #                                                                     #
    #   You should have received a copy of the GNU Lesser General Public  #
    #   License  along  with  this  library;  if  not, write to the Free  #
    #   Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA  #
    #   02111-1307 USA                                                    #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   If you have any questions or comments, please email:              #
    #                                                                     #
    #   Silvio Ricci                                                      #
    #   rhadrix@users.sourceforge.net                                     #
    #   http://if-cms.sourceforge.net                                     #
    #                                                                     #
    #######################################################################

if (!defined("_INI_RNS")) die("OOPS! Non puoi accedere a questo file direttamente");
echo _INI_PAG;
$no_dx = '1';
include $dirs->get('header');
include $dirs->get('left');
if (!defined("MY_RSS")) {
    define("MY_RSS", "defined");

    function rss_start_element($parser, $name, $attributes)
    {
        global $rss;
        $rss->start_element($parser, $name, $attributes);
    } 

    function rss_end_element($parser, $name)
    {
        global $rss;
        $rss->end_element($parser, $name);
    } 

    function rss_character_data($parser, $data)
    {
        global $rss;
        $rss->character_data($parser, $data);
    } 
    class rss_parser {
        function rss_parser()
        {
            $this->error = '';
            $this->file = '';
            $this->channel = array();
            $this->data = '';
            $this->stack = array();
            $this->num_items = 0;
            $this->xml_parser = xml_parser_create();
            xml_set_element_handler($this->xml_parser, "rss_start_element", "rss_end_element");
            xml_set_character_data_handler($this->xml_parser, "rss_character_data");
        } 
        function character_data($parser, $data)
        {
            if (empty($this->data)) $this->data = trim($data);
            else $this->data .= ' ' . trim($data);
        } 
        function start_element($parser, $name, $attrs)
        {
            switch ($name) {
                case 'RSS':
                    break;
                case 'CHANNEL':
                    break;
                case 'IMAGE':
                    array_push($this->stack, $name);
                    break;
                case 'ITEM':
                    array_push($this->stack, $name);
                    array_push($this->stack, $this->num_items);
                    $this->item[$this->num_items] = array();
                    $this->num_items++;
                    break;
                case 'TEXTINPUT':
                    array_push($this->stack, $name);
                    break;
                default:
                    array_push($this->stack, $name);
                    break;
            } 
        } 
        function end_element($parser, $name)
        {
            switch ($name) {
                case 'RSS':
                    break;
                case 'CHANNEL':
                    break;
                case 'IMAGE':
                    array_pop($this->stack);
                    break;
                case 'ITEM':
                    array_pop($this->stack);
                    array_pop($this->stack);
                    break;
                case 'TEXTINPUT':
                    array_pop($this->stack);
                    break;
                default:
                    $element = (implode("']['", $this->stack));
                    eval("\$this->channel['$element']=\$this->data;"); // this does all the hard work.
                    array_pop($this->stack);
                    $this->data = '';
                    break;
            } 
        } 
        function parse()
        {
            global $OBJ;
            if (!($fp = @fopen($this->file, "r"))) {
                $this->error = "1:::not_open:::$this->file";
                return false;
            } while ($data = fread($fp, 4096)) {
                if (!xml_parse($this->xml_parser, $data, feof($fp))) {
                    $this->error = sprintf("2:::xml_error:::%s:::at_line:::%d", xml_error_string(xml_get_error_code($this->xml_parser)), xml_get_current_line_number($this->xml_parser));
                    return false;
                } 
            } 
            array_push($OBJ, &$this);
            xml_parser_free($this->xml_parser);
            return true;
        } 
        function destroy()
        {
            $this->$this->xml_parser = null;
        } 
    } 
} 
$tXt = $xQ->get_txt('sf');
$rss = new rss_parser();
$rss->file = "http://sourceforge.net/export/rss2_projnews.php?group_id=85317&rss_fulltext=1";
if ($rss->parse()) {
    $sf_news = $rss->channel;
    echo $XL->module_tit("If-CMS News");
    echo '<BLOCKQUOTE>' . $sf_news[DESCRIPTION] . '</BLOCKQUOTE>' . _CRLF
     . '<BLOCKQUOTE>' . _CRLF
     . '<A target="_blank" href="' . $sf_news[LINK] . '"' . $XL->staturl() . '>' . $cXc["here"] . '</A> ' . $tXt["lastest"];
    echo $tXt["news_fs"] . '</BLOCKQUOTE>';
    $size = sizeof($sf_news[ITEM])-1;
    for($i = 0, $j = 5; $i <= $size; $i++, $j--) {
        if ($j) {
            echo '<BLOCKQUOTE><B>' . $sf_news[ITEM][$i][TITLE] . '</B><BR>';
            $body = eregi_replace("< ", "<", $sf_news[ITEM][$i][DESCRIPTION]);
            $body = eregi_replace(" >", ">", $body);
            echo $body . _CRLF
             . '<BR><BR><FONT SIZE="1">' . $tXt["posted_by"] . ' ' . $sf_news[ITEM][$i][AUTHOR] . '<BR>' . $tXt["date"] . ' ' . $sf_news[ITEM][$i][PUBDATE] . '</FONT>' . _CRLF
             . '</BLOCKQUOTE>' . _CRLF;
            if ($i == "0") echo '<BLOCKQUOTE>' . $tXt["post_you"] . ' <A target="_blank" href="' . $sf_news[ITEM][$i][COMMENTS] . '"' . $XL->staturl() . '>' . $tXt["here"] . '</A> ' . $tXt["go_forum"] . ' <A target="_blank" href="' . $sf_news[ITEM][$i][LINK] . '"' . $XL->staturl() . '>' . $tXt["here"] . '</A></BLOCKQUOTE>' . _CRLF;
        } 
    } 
    echo '<CENTER><A href="http://sourceforge.net" target="_blank"' . $XL->staturl("SourceForge.net Logo") . '><IMG src="http://sourceforge.net/sflogo.php?group_id=85317&amp;type=5" width="210" height="62" border="0" alt="SourceForge.net Logo"></A></CENTER>' . _CRLF
     . '<BR><CENTER><FONT color="indianred" SIZE="1">' . $tXt["generate_by"] . ' <I>' . $sf_news[GENERATOR] . '<I><BR>' . $tXt["last_update"] . ' ' . $sf_news[LASTBUILDDATE] . '</FONT></CENTER>' . _CRLF;
} elseif ($rss->error) {
    echo $XL->module_tit($tXt["parse_error"]);
    echo '<BR><BLOCKQUOTE>' . _CRLF;
    $a = explode(":::", $rss->error);
    if ($a[0] == 1) echo $tXt[$a[1]] . ' ' . $a[2];
    elseif ($a[0] == 2) echo $tXt[$a[1]] . ' ' . $a[2] . ' ' . $a[3] . ' ' . $a[4];
    echo '</BLOCKQUOTE>' . _CRLF;
} 

    #######################################################################
    #       _____    _     _    ___    _____    _____    _  _     _       #
    #      (_____ \ ( )   ( ) / ___ \ (  _   \ (_____ \ ( )( |   | )      #
    #       _____) )) (___) () (___) () (  \  ) _____) )) ( \ \ / /       #
    #      (  __  / (  ___  )(  ___  )( |   ) )(  __  / ( )  >   <        #
    #      ) (  \ \ ) (   ) () (   ) () (_ /  )) (  \ \ ) ( / / \ \       #
    #      (_)   |_)(_)   (_)(_)   (_)(_____ / (_)   |_)(_)(_|   |_)      #
    #                                                                     #
    #######################################################################
?>
