<?php

    #######################################################################
    #                                                                     #
    #              If-CMS - Content Management System for PHP             #
    #              ==========================================             #
    #                                                                     #
    #                    Copyright (c) 2003 Silvio Ricci                  #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   This library is free  software; you can  redistribute it and/or   #
    #   modify  it under  the  terms of the GNU Lesser  General  Public   #
    #   License as published by the  Free  Software  Foundation; either   #
    #   version 2.1 of the License, or any later version.                 #
    #                                                                     #
    #   This library is distributed  in the hope that it will be useful,  #
    #   but WITHOUT  ANY  WARRANTY; without even the implied warranty of  #
    #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  #
    #   Lesser General Public License for more details.                   #
    #                                                                     #
    #   You should have received a copy of the GNU Lesser General Public  #
    #   License  along  with  this  library;  if  not, write to the Free  #
    #   Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA  #
    #   02111-1307 USA                                                    #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   If you have any questions or comments, please email:              #
    #                                                                     #
    #   Silvio Ricci                                                      #
    #   ifcms@rhadrix.com                                                 #
    #   http://www.rhadrix.com/ifcms                                      #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #                       AlberT-CodFis-1.5                             #
    #                                                                     #
    #  Questo programma  Free Software, by Emiliano <AlberT> Gabrielli.  #
    #                                                                     #
    #  Qualsiasi uso o modifica di questo programma deve sottostare alla  #
    #  alla Gnu GPL 2. Il suo uso e diffusione e' incentivato dal'autore, #
    #  ma ne e' espressamente vietata la modifica e/o la distribuzione se #
    #  non sotto questa stessa licenza.                                   #
    #                                                                     #
    #  Questa licenza NON DEVE ESSERE RIMOSSA!                            #
    #                                                                     #
    #  Per bugs, consigli e quant'altro ( ringraziamenti!?!! :-)  )       #
    #  contattate l'autore all'indirizzo e-mail:  AlberT@SuperAlberT.it   #
    #  e visitate il sito:  http://www.SuperAlberT.it                     #
    #                                                                     #
    #  Questo programma  stato possibile grazie ai sorgenti di           #
    #  kodicefiscale di Catuzzi Samuele <samuele.c@yahoo.it> !            #
    #                                                                     #
    #  Un ringraziamento va a Valter Sini che mi ha segnalato un bug nel  #
    #  calcolo del codice per cognomi come il suo. :-)                    #
    #                                                                     #
    #  Grazie agli amici di php-it@ziobudda.net  stata semplificata la   #
    #  procedura di controllo della data con l'uso  di checkdate().       #
    #                                                                     #
    #######################################################################

if (!defined("_INI_RNS")) die("OOPS! Non puoi accedere a questo file direttamente");
if (!function_exists('levaconsonanti')) {
    $CFconf["thisdir"] = $dirs->get('plug') . 'scripts/';
    function levaconsonanti($stringa)
    {
        $temp = str_replace(" ", "", $stringa);
        $temp = ereg_replace("[BCDFGHJKLMNPQRSTVWXYZ]", "", $temp);
        return $temp;
    } 
    function levavocali($stringa)
    {
        $temp = str_replace(" ", "", $stringa);
        $temp = ereg_replace("[AEIOU]", "", $temp);
        return $temp;
    } 
    function levastranezze($stringa)
    {
        $stringa = str_replace("' ", " ", $stringa);
        $stringa = str_replace("'", " ", $stringa);
        $stringa = str_replace("", "a", $stringa);
        $stringa = str_replace("", "e", $stringa);
        $stringa = str_replace("", "e", $stringa);
        $stringa = str_replace("", "i", $stringa);
        $stringa = str_replace("", "o", $stringa);
        $stringa = str_replace("", "u", $stringa);
        $stringa = str_replace("-", "", $stringa);
        $stringa = str_replace("[", "", $stringa);
        $stringa = str_replace("]", "", $stringa);
        $stringa = ereg_replace("[\\\"!?^$|%&)(=`,;:.+*/<>@#]", "", $stringa);
        $stringa = trim($stringa);
        return $stringa;
    } 
    function sceglifile($comune)
    {
        $temp = strtoupper($comune);
        $iniziale = substr($temp, 0, 1);
        if (strchr("ABCDE", $iniziale)) $suffisso = "1";
        elseif (strchr("FGHIJKLMNOPQR", $iniziale)) $suffisso = "2";
        elseif (strchr("STUVWXYZ", $iniziale)) $suffisso = "3";
        else {
            $error = "ERRORE!!! \nERRORE: il comune DEVE iniziare con una lettera!!";
            return $error;
        } 
        $file = "comuni_$suffisso.dat";
        return $file;
    } 
    function cercacitta($comune)
    {
        global $CFconf;
        if ($comune == "") {
            $error = "ERRORE: SPECIFICARE UN COMUNE!";
            return $error;
        } 
        $error = "Errore!!!\n Non  stato possibile trovare il Comune. Verificare i dati.";
        $comune = strtoupper(substr($comune, 0, 20));
        $dati = file($CFconf["thisdir"] . sceglifile($comune));
        for ($i = 0;$i < sizeof($dati);$i++) {
            $daticitta = split(":", $dati[$i], 3) ;
            $daticitta[0] = str_replace(" ", "", $daticitta[0]);
            $comune = str_replace(" ", "", $comune);
            if ($daticitta[0] == $comune) {
                $trovato = 1;
                break;
            } 
        } 
        $ritorna = ($trovato) ? $daticitta : $error;
        return $ritorna;
    } 
    function controlladati($cognome, $nome, $datadinascita, $sesso, $citta)
    {
        if ((strlen($datadinascita) != 8) || ($datadinascita <= 0)) {
            $error = "Errore nella data di nascita, la data deve essere nella forma ggmmaaaa";
            return $error;
        } 
        $giorno = substr($datadinascita, 0, 2);
        $mese = substr($datadinascita, 2, 2);
        $anno = substr($datadinascita, 4, 4);
        $error = "Errore nella data di nascita, la data non risulta valida!";
        if (!checkdate($mese, $giorno, $anno)) return $error;
        $sesso = strtoupper($sesso);
        if (($sesso != "M") && ($sesso != "F")) {
            $error = "Errore !!!  Errore nel campo 'sesso' (M/F)" ;
            return $error;
        } 
        if ($citta == "") {
            $error = "Errore !!!\nErrore, specificare il comune di nascita." ;
            return $error;
        } else {
            $daticitta = cercacitta($citta);
            if (gettype ($daticitta) == "string") return $daticitta;
            $sigla = $daticitta[1];
            $cod_comune = $daticitta[2];
        } 
        if ((strlen($cognome) == 0)) {
            $error = "Errore !!!\nErrore sul campo Cognome, dato non valido.";
            return $error;
        } 
        if ((strlen($nome) == 0)) {
            $error = "Errore !!!\nErrore sul campo Nome, dato non valido.";
            return $error;
        } 
        return $daticitta;
    } 
    function AlberT_CodFis($cognome, $nome, $datadinascita, $sesso, $citta)
    {
        static $error;
        $nome = levastranezze($nome);
        $cognome = levastranezze($cognome);
        $citta = levastranezze($citta);
        $cod_comune = "";
        $numvocali = 0;
        $numconsonanti = 0;
        $numeri = "0123456789";
        $alfabeto = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $alfabeto_dispari = "BAKPLCQDREVOSFTGUHMINJWZYX";
        $daticitta = controlladati($cognome, $nome, $datadinascita, $sesso, $citta);
        if (gettype($daticitta) == "string") return $daticitta;
        $sigla = $daticitta[1];
        $cod_comune = $daticitta[2];
        $ooe = levaconsonanti(strtoupper($cognome));
        $cgnm = levavocali(strtoupper($cognome));
        $numvocali = strlen($ooe);
        $numconsonanti = strlen($cgnm);
        switch ($numconsonanti) {
            case 0 :
                if ($numvocali == 2) $codicefiscale = $ooe . "X";
                else {
                    $error = "Errore !!! \nErrore sul cognome, caso non previsto da questo algoritmo \n...impossibile calcolare il codice fiscale.";
                    return $error;
                } 
                break;
            case 1 :
                switch ($numvocali) {
                    case 0:
                        $error = "Errore !!! \nErrore sul cognome, caso non previsto da questo algoritmo \n...impossibile calcolare il codice fiscale.";
                        return $error;
                    case 1 :
                        $codicefiscale = $cgnm . $ooe . "X";
                        break;
                    default :
                        $codicefiscale = $cgnm . substr ($ooe, 0, 2);
                        break;
                } 
                break;
            case 2 :
                if ($numvocali >= 1) $codicefiscale = $cgnm . substr($ooe, 0, 1);
                else {
                    $error = "Errore !!! \nErrore sul cognome, caso non previsto da questo algoritmo \n...impossibile calcolare il codice fiscale";
                    return $error;
                } 
                break;
            default :
                $codicefiscale = substr($cgnm, 0, 3);
                break;
        } 
        $oe = levaconsonanti(strtoupper($nome));
        $nm = levavocali(strtoupper($nome));
        $numvocali = strlen($oe);
        $numconsonanti = strlen($nm);
        switch ($numconsonanti) {
            case 0 :
                if ($numvocali == 2) $codicefiscale .= $oe . "X";
                else {
                    $error = "Errore !!! \nErrore sul nome, caso non previsto da questo algoritmo \n...impossibile calcolare il codice fiscale";
                    return $error;
                } 
                break;
            case 1 :
                switch ($numvocali) {
                    case 0 :
                        $error = "Errore !!! \nErrore sul nome, caso non previsto da questo algoritmo \n...impossibile calcolare il codice fiscale";
                        return $error;
                    case 1 :
                        $codicefiscale .= $nm . substr($oe, 0, 1) . "X";
                        break;
                    default :
                        $codicefiscale .= $nm . substr($oe, 0, 2);
                        break;
                } 
                break;
            case 2 :
                if ($numvocali >= 1) $codicefiscale .= substr($nm, 0, 2) . substr($oe, 0, 1);
                else {
                    $error = "Errore !!! \nErrore sul nome, caso non previsto da questo algoritmo \n...impossibile calcolare il codice fiscale";
                    return $error;
                } 
                break;
            case 3 :
                $codicefiscale .= $nm;
                break;
            default :
                $codicefiscale .= substr($nm, 0, 1) . substr($nm, 2, 2);
                break;
        } 
        $codicefiscale .= substr($datadinascita, -2);
        (int)$mese = substr($datadinascita, 2, 2);
        switch ($mese) {
            case 1 : $codicefiscale .= 'A' ;
                break;
            case 2 : $codicefiscale .= 'B' ;
                break;
            case 3 : $codicefiscale .= 'C' ;
                break;
            case 4 : $codicefiscale .= 'D' ;
                break;
            case 5 : $codicefiscale .= 'E' ;
                break;
            case 6 : $codicefiscale .= 'H' ;
                break;
            case 7 : $codicefiscale .= 'L' ;
                break;
            case 8 : $codicefiscale .= 'M' ;
                break;
            case 9 : $codicefiscale .= 'P' ;
                break;
            case 10 : $codicefiscale .= 'R' ;
                break;
            case 11 : $codicefiscale .= 'S' ;
                break;
            case 12 : $codicefiscale .= 'T' ;
                break;
            default :
                $error = "  Errore !!! \nErrore sul mese, dato non valido.";
                return $error;
        } 
        (int)$giorno = substr($datadinascita, 0, 2);
        $sesso = strtoupper($sesso);
        if ($sesso == 'M') $codicefiscale .= substr($datadinascita, 0, 2);
        else {
            $giorno += 40;
            $codicefiscale .= substr($numeri, $giorno / 10, 1);
            $codicefiscale .= substr($numeri, $giorno % 10, 1);
        } 
        $codicefiscale .= trim($cod_comune);
        $numero = 0;
        for($i = 0; $i <= 14; $i += 2) {
            if (strchr($numeri, substr($codicefiscale, $i, 1)) == false) {
                for($j = 0; $j <= 26; $j++) {
                    if (substr($codicefiscale, $i, 1) == substr($alfabeto_dispari, $j, 1)) {
                        $numero += $j;
                        break;
                    } 
                } 
            } else {
                switch (substr($codicefiscale, $i, 1)) {
                    case '0' : $numero += 1;
                        break;
                    case '1' : break;
                    case '2' : $numero += 5;
                        break;
                    case '3' : $numero += 7;
                        break;
                    case '4' : $numero += 9;
                        break;
                    case '5' : $numero += 13;
                        break;
                    case '6' : $numero += 15;
                        break;
                    case '7' : $numero += 17;
                        break;
                    case '8' : $numero += 19;
                        break;
                    case '9' : $numero += 21;
                        break;
                } 
            } 
        } 
        for($i = 1;$i <= 13;$i += 2) {
            if (strchr($numeri, substr($codicefiscale, $i, 1)) == false) {
                for($j = 0;$j <= 26;$j++) {
                    if (substr($codicefiscale, $i, 1) == substr($alfabeto, $j, 1)) {
                        $numero += $j;
                        break;
                    } 
                } 
            } else $numero += substr($codicefiscale, $i, 1);
        } 
        $numero = $numero % 26;
        $codicefiscale .= substr($alfabeto, $numero, 1);
        return $codicefiscale ;
    } 
} 

    #######################################################################
    #       _____    _     _    ___    _____    _____    _  _     _       #
    #      (_____ \ ( )   ( ) / ___ \ (  _   \ (_____ \ ( )( |   | )      #
    #       _____) )) (___) () (___) () (  \  ) _____) )) ( \ \ / /       #
    #      (  __  / (  ___  )(  ___  )( |   ) )(  __  / ( )  >   <        #
    #      ) (  \ \ ) (   ) () (   ) () (_ /  )) (  \ \ ) ( / / \ \       #
    #      (_)   |_)(_)   (_)(_)   (_)(_____ / (_)   |_)(_)(_|   |_)      #
    #                                                                     #
    #######################################################################
?>