<?php
/*
    CurrencyConverter ver 1.0.0
    Author: Daniel Kushner
    Email: daniel@websapp.com
    Release: 1 Nov 2001
    Copyright 2001
    
    CurrencyConverter can convert from USD, CAD, EUR and GBP to 
    over 150 different currencies 
*/
if (!defined("CURRENCY")) {
    define("CURRENCY", "defined");
    class CurrencyConverter {
        /**
         * * A list of all the currencies with their codes is at the end of this file *
         */
        // The conversion rates
        var $conv; 
        // The names of the currencies
        var $names; 
        // A list that keeps the name of currencies that are realy 'aliases' to
        // the same currency but with a different name
        var $blacklist = array('Nauru Island Dollar' => true,
            'Christmas Island Dollar' => true,
            'Cocoskeeling Island' => true,
            'Norfolk Island Dollar' => true,
            'Kiribati Dollar' => true,
            'Tuvalu Dollar' => true,
            'Heard & Mcdonald Island Dollar' => true,
            'Liechtenstein Franc' => true,
            'Faroe Island Krone' => true,
            'North Africa Peseta' => true,
            'French Guiana Franc' => true,
            'Guadaloupe Franc' => true,
            'St. Pierre Franc' => true,
            'Miquelon Franc' => true,
            'Andorran Franc' => true,
            'Monaco Franc' => true,
            'Martinique Franc' => true,
            'Reunion Franc' => true,
            'San Marino Lira' => true,
            'Vatican City Lira' => true,
            'Dronning Maudland Krone' => true,
            'Bouvet Island Kroner' => true,
            'Pitcairn Island Dollar' => true,
            'Tokelau Dollar' => true,
            'Nieue Dollar' => true,
            'Azores Escudo' => true,
            'Madeira Escudo' => true,
            'Samoa American Dollar' => true,
            'Johnston Island Dollar' => true,
            'Midway Island Dollar' => true,
            'Turks & Caicos Dollar' => true,
            'Virgin Island Dollar' => true,
            'Puerto Rico Dollar' => true,
            'Brit. Indian Ocean Terr.' => true,
            'Guam Dollar' => true,
            'Cameroon Franc' => true,
            'Congo Franc' => true,
            'Equatorial Guinea' => true,
            'Gabon Franc' => true,
            'Chad Franc' => true,
            'St. Lucia Dollar' => true,
            'Dominica Dollar' => true,
            'Grenada Dollar' => true,
            'St. Kitts Dollar' => true,
            'Montserrat Dollar' => true,
            'St. Vincent Dollar' => true,
            'East Caribbean Dollar' => true,
            'Burkino Faso' => true,
            'Senegal Franc' => true,
            'Togo Republic Franc' => true,
            'Ivory Coast Franc' => true,
            'Mali Republic Franc' => true,
            'Benin Franc' => true,
            'Namibia Dollar' => true,
            'South African Rand/fin' => true
            ); 
        // Constants
        var $URL = "pacific.commerce.ubc.ca";
        var $URI = "/xr/rates.html";
        var $fp;
        /* 
        Constructs a new Converter and updates the 
        conversion and names arrays
        */
        function CurrencyConverter()
        {
            $this->fp = fsockopen($this->URL, 80, $errno, $errstr, 60);
            if (!$this->fp) {
                echo "$errstr ($errno)<br>\n";
            } else {
                fputs ($this->fp, "GET $this->URI HTTP/1.0\r\n\r\n");
                while (!feof($this->fp)) {
                    $line = fgets ($this->fp, 1024);
                    if (eregi("<tt>([[:alnum:]]+)</tt>", $line, $reg)) {
                        $currency = $reg[1];
                        $line = fgets ($this->fp, 1024);
                        eregi(">([^<]+)</", $line, $reg);
                        if ($this->blacklist[$reg[1]]) continue;
                        $this->names[$currency] = $reg[1];
                        $this->enterConvertion('CAD', $currency);
                        $this->enterConvertion('USD', $currency);
                        $this->enterConvertion('EUR', $currency);
                        $this->enterConvertion('GBP', $currency);
                    } 
                } 
                fclose ($this->fp);
            } 
        } 
        /*
        Given two currency codes returns their exchange rate.
        */
        function convert($from, $to)
        {
            return $this->conv[$from][$to];
        } 
        /*
        Given a curreny code returns it's full name.
        */
        function getName($currency)
        {
            return $this->names[$currency];
        } 
        /*  PRIVATE FUNCTIONS   */
        function enterConvertion($from, $to)
        {
            $line = fgets ($this->fp, 1024);
            eregi(">([^<]+)</", $line, $reg);
            $this->conv[$from][$to] = $reg[1];
        } 
    } 
} 

?>