<?php

    #######################################################################
    #                                                                     #
    #              If-CMS - Content Management System for PHP             #
    #              ==========================================             #
    #                                                                     #
    #                    Copyright (c) 2003 Silvio Ricci                  #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   This library is free  software; you can  redistribute it and/or   #
    #   modify  it under  the  terms of the GNU Lesser  General  Public   #
    #   License as published by the  Free  Software  Foundation; either   #
    #   version 2.1 of the License, or any later version.                 #
    #                                                                     #
    #   This library is distributed  in the hope that it will be useful,  #
    #   but WITHOUT  ANY  WARRANTY; without even the implied warranty of  #
    #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  #
    #   Lesser General Public License for more details.                   #
    #                                                                     #
    #   You should have received a copy of the GNU Lesser General Public  #
    #   License  along  with  this  library;  if  not, write to the Free  #
    #   Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA  #
    #   02111-1307 USA                                                    #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   If you have any questions or comments, please email:              #
    #                                                                     #
    #   Silvio Ricci                                                      #
    #   ifcms@rhadrix.com                                                 #
    #   http://www.rhadrix.com/ifcms                                      #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   The Following code is taken from phpmyadmin and is altered in     #
    #   order to adapte it here.                                          #
    #   phpMyAdmin is a free open source resource to administrate MySQL   #
    #   over the WWW. The latest download is at http://phpmyadmin.net     #
    #                                                                     #
    #######################################################################

if (!defined("_INI_RNS")) die("OOPS! Non puoi accedere a questo file direttamente");
include $dirs->get('funcs');
include $dirs->get('queries');
$xQ = new my_queries($dbi, $table);
$tXt = $xQ->get_txt('backup');
set_time_limit(0);
$rope = "";
if (!function_exists('my_handler')) {
    $client = getenv("HTTP_USER_AGENT");
    if (ereg('[^(]*\((.*)\)[^)]*', $client, $regs)) {
        if (eregi("Win", $regs[1])) $crlf = "\r\n";
    } 
    function my_handler($sql_insert)
    {
        global $crlf, $rope;
        $rope .= "$sql_insert;$crlf";
    } 
    function get_table_content($tabella, $handler)
    {
        global $dbi;
        $i = 0;
        $result = $dbi->sql_query("SELECT * FROM $tabella");
        $numfileds = $dbi->sql_numfields($result);
        while ($row = $dbi->sql_fetchrow($result)) {
            $table_list = "(";
            for($j = 0; $j < $numfileds;$j++) $table_list .= $dbi->sql_fieldname($j) . ", ";
            $table_list = substr($table_list, 0, -2);
            $table_list .= ")";
            if (isset($GLOBALS["showcolumns"])) $schema_insert = "INSERT INTO $tabella $table_list VALUES (";
            else $schema_insert = "INSERT INTO $tabella VALUES (";
            for($j = 0; $j < $numfileds;$j++) {
                if (!isset($row[$j])) $schema_insert .= " NULL,";
                elseif ($row[$j] != "") $schema_insert .= " '" . addslashes($row[$j]) . "',";
                else $schema_insert .= " '',";
            } 
            $schema_insert = ereg_replace(",$", "", $schema_insert);
            $schema_insert .= ")";
            $handler(trim($schema_insert));
            $i++;
        } 
        return (true);
    } 
    function get_table_def($tabella, $crlf)
    {
        global $dbi;
        $schema_create = "";
        $schema_create .= "DROP TABLE IF EXISTS $tabella;$crlf";
        $schema_create .= "CREATE TABLE $tabella ($crlf";
        $result = $dbi->sql_query("SHOW FIELDS FROM $tabella");
        while ($row = $dbi->sql_fetchrow($result)) {
            $schema_create .= "   $row[Field] $row[Type]";
            if (isset($row["Default"]) && (!empty($row["Default"]) || $row["Default"] == "0")) $schema_create .= " DEFAULT '$row[Default]'";
            if ($row["Null"] != "YES") $schema_create .= " NOT NULL";
            if ($row["Extra"] != "") $schema_create .= " $row[Extra]";
            $schema_create .= ",$crlf";
        } 
        $schema_create = ereg_replace("," . $crlf . "$", "", $schema_create);
        $result = $dbi->sql_query("SHOW KEYS FROM " . $tabella);
        while ($row = $dbi->sql_fetchrow($result)) {
            $kname = $row['Key_name'];
            $comment = (isset($row['Comment'])) ? $row['Comment'] : '';
            $sub_part = (isset($row['Sub_part'])) ? $row['Sub_part'] : '';
            if (($kname != "PRIMARY") && ($row['Non_unique'] == 0)) $kname = "UNIQUE|$kname";
            if ($comment == "FULLTEXT") $kname = "FULLTEXT|$kname";
            if (!isset($index[$kname])) $index[$kname] = array();
            if ($sub_part > 1) $index[$kname][] = $row['Column_name'] . "(" . $sub_part . ")";
            else $index[$kname][] = $row['Column_name'];
        } while (list($x, $columns) = @each($index)) {
            $schema_create .= ",$crlf";
            if ($x == "PRIMARY") $schema_create .= "   PRIMARY KEY (" . implode($columns, ", ") . ")";
            elseif (substr($x, 0, 6) == "UNIQUE") $schema_create .= "   UNIQUE " . substr($x, 7) . " (" . implode($columns, ", ") . ")";
            elseif (substr($x, 0, 8) == "FULLTEXT") $schema_create .= "   FULLTEXT " . substr($x, 9) . " (";
            else $schema_create .= "   KEY $x (" . implode($columns, ", ") . ")";
        } 
        $schema_create .= "$crlf)";
        if (get_magic_quotes_gpc()) return (stripslashes($schema_create));
        else return ($schema_create);
    } 
} 
$tables = $dbi->sql_query("SHOW TABLES FROM $nbase");
$num_tables = $dbi->sql_numrows($tables);
if ($num_tables == 0) echo $tXt["no_tables_found"];
else {
    $oggi = date("m-d-Y");
    for($i = 0;$i < $num_tables;$i++) $tabl[$i] = $dbi->sql_tablename($i);
    $adesso = date ("H:i");
    $rope .= "# ========================================================$crlf";
    $rope .= "#$crlf";
    $rope .= "# " . $tXt["name"] . " : " . $nbase . $crlf;
    $rope .= "# " . $tXt["done"] . " " . $oggi . " " . $tXt["at"] . " " . $adesso . " " . $tXt["by"] . " " . $nome_adm . $crlf;
    $rope .= "#$crlf";
    $rope .= "# ========================================================$crlf";
    $rope .= "$crlf";
    $i = 0;
    while ($i < $num_tables) {
        $tabella = $tabl[$i];
        $rope .= $crlf;
        $rope .= "# --------------------------------------------------------$crlf";
        $rope .= "#$crlf";
        $rope .= "# " . $tXt["table_structure"] . " " . $tabella . $crlf;
        $rope .= "#$crlf";
        $rope .= $crlf;
        $rope .= get_table_def($tabella, $crlf) . ";$crlf$crlf";
        $rope .= "#$crlf";
        $rope .= "# " . $tXt["dumping_data"] . " $tabella $crlf";
        $rope .= "#$crlf";
        $rope .= $crlf;
        get_table_content($tabella, "my_handler");
        $i++;
    } 
    include $dirs->get('zip_file');
    $zipfile = new zipfile();
    $filedata = $rope;
    $zipfile->add_file($filedata, "file.sql");
    echo $zipfile->file();
} 
register_shutdown_function("finalize"); 

    #######################################################################
    #       _____    _     _    ___    _____    _____    _  _     _       #
    #      (_____ \ ( )   ( ) / ___ \ (  _   \ (_____ \ ( )( |   | )      #
    #       _____) )) (___) () (___) () (  \  ) _____) )) ( \ \ / /       #
    #      (  __  / (  ___  )(  ___  )( |   ) )(  __  / ( )  >   <        #
    #      ) (  \ \ ) (   ) () (   ) () (_ /  )) (  \ \ ) ( / / \ \       #
    #      (_)   |_)(_)   (_)(_)   (_)(_____ / (_)   |_)(_)(_|   |_)      #
    #                                                                     #
    #######################################################################
?>
