<?php

    #######################################################################
    #                                                                     #
    #              If-CMS - Content Management System for PHP             #
    #              ==========================================             #
    #                                                                     #
    #                    Copyright (c) 2003 Silvio Ricci                  #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   This library is free  software; you can  redistribute it and/or   #
    #   modify  it under  the  terms of the GNU Lesser  General  Public   #
    #   License as published by the  Free  Software  Foundation; either   #
    #   version 2.1 of the License, or any later version.                 #
    #                                                                     #
    #   This library is distributed  in the hope that it will be useful,  #
    #   but WITHOUT  ANY  WARRANTY; without even the implied warranty of  #
    #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  #
    #   Lesser General Public License for more details.                   #
    #                                                                     #
    #   You should have received a copy of the GNU Lesser General Public  #
    #   License  along  with  this  library;  if  not, write to the Free  #
    #   Software Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA  #
    #   02111-1307 USA                                                    #
    #                                                                     #
    #######################################################################
    #                                                                     #
    #   If you have any questions or comments, please email:              #
    #                                                                     #
    #   Silvio Ricci                                                      #
    #   ifcms@rhadrix.com                                                 #
    #   http://www.rhadrix.com/ifcms                                      #
    #                                                                     #
    #######################################################################


include_once './inc/config.php';
require("./inc/rss/xml_writer_class.php");
require("./inc/rss/rss_writer_class.php");

$rss_object = new rss_writer_class;

$result = $dbi->sql_query("SELECT my_web,titulo,descripcion FROM ".$table->get('meta'));

$row = $dbi->sql_fetchrow($result);
$my_url = $row["my_web"];
$titulo = $row["titulo"];
$descripcion = $row["descripcion"];

$hoy =  date("Y-m-d H:i:s");
$b = explode(" ",$hoy);

$rss_object->specification = "1.0";
$rss_object->about = "$my_url/inc/rss/channels.xml";
$rss_object->stylesheet = "$my_url/inc/rss/rss2html.xsl";
$rss_object->rssnamespaces["dc"]="http://purl.org/dc/elements/1.1/";

$properties=array();
$properties["description"] = $descripcion;
$properties["link"] = $my_url;
$properties["title"] = $titulo;
$properties["dc:date"] = "$b[0]T$b[1]Z";
$rss_object->addchannel($properties);

$properties=array();
$properties["url"] = "$my_url/img/banners/mainbanner.gif";
$properties["link"] = $my_url;
$properties["title"] = $titulo;
$properties["description"] = $descripcion;
$rss_object->addimage($properties);

$properties=array();
$result = $dbi->sql_query("SELECT id_news,titl_news,main_news,data_news FROM ".$table->get('news')." WHERE attivo='1' ORDER BY data_news DESC LIMIT 15");

if (!$result) {
    $properties["description"]="Latest articles made available";
    $properties["link"]="$my_url/index.php?rns=news";
    $properties["title"]="Latest articles entries";
    $properties["dc:date"]="$b[0]T$b[1]Z";
    $rss_object->additem($properties);
} else {
    while($row = $dbi->sql_fetchrow($result)) {
        $id_news = $row["id_news"];
        $t = explode(" ",$row["data_news"]);
        $title = htmlspecialchars($row["titl_news"]);
        $hometext = htmlspecialchars($row["main_news"]);
        $hometext = str_replace("<br>","<br />",$hometext);
        $properties["description"]= $hometext;
        $properties["link"] = "$my_url/index.php?rns=news&id_news=$id_news";
        $properties["title"] = $title;
        $properties["dc:date"] = "$t[0]T$t[1]Z";
        $rss_object->additem($properties);
    }
}

$properties=array();
$properties["name"] = "a";
$properties["link"] = "$my_url/index.php?a";
$properties["title"] = "Search for:";
$properties["description"] = "Search in the $titulo Site repository";
$rss_object->addtextinput($properties);

if($rss_object->writerss($output)) {
    Header("Content-Type: text/xml; charset=\"".$rss_object->outputencoding."\"");
    Header("Content-Length: ".strval(strlen($output)));
    echo $output;
} else {
    Header("Content-Type: text/plain");
    echo ("Error: ".$rss_object->error);
}

    #######################################################################
    #       _____    _     _    ___    _____    _____    _  _     _       #
    #      (_____ \ ( )   ( ) / ___ \ (  _   \ (_____ \ ( )( |   | )      #
    #       _____) )) (___) () (___) () (  \  ) _____) )) ( \ \ / /       #
    #      (  __  / (  ___  )(  ___  )( |   ) )(  __  / ( )  >   <        #
    #      ) (  \ \ ) (   ) () (   ) () (_ /  )) (  \ \ ) ( / / \ \       #
    #      (_)   |_)(_)   (_)(_)   (_)(_____ / (_)   |_)(_)(_|   |_)      #
    #                                                                     #
    #######################################################################
?>